
/*
   2-RGB-Colour Challenge:
   Use the potentiometer as smooth analog colour selector (scroll through all the hues of colour).

   Hints: Common anode (CA) RGBs are 3 (red, green, blue) LEDs that share a common +5V.
          CA-RGBs are "backwards" from conventional LEDs.
          0/LOW is 100% ON, and 255/HIGH is 100% OFF.
*/

//potentiometer connected to A0
const int pot = A0;

//RGB connected to pins 9, 10, 11
const int red = 9;
const int green = 10;
const int blue = 11;

//create variable for potentiometer value
int potValue = 0;
//create a variable to scale the potValue to 0-255
int scaleValue = 0;

void setup() {
  //set potentiometer to input
  pinMode(pot, INPUT);
  //set LEDs to output
  pinMode(red, OUTPUT);
  pinMode(green, OUTPUT);
  pinMode(blue, OUTPUT);
}

void loop() {

  //read pot and assign to potValue (0-1023)
  potValue = analogRead(pot);

  //potValue    LED colour

  //0-127       all LEDs off
  //128-383     fade red to green
  //384-639     fade green to blue
  //640-895     fade blue to red
  //896-1023    all LEDs on

  //0-127: all LEDs off
  if (potValue < 128) {
    digitalWrite(red, HIGH);
    digitalWrite(green, HIGH);
    digitalWrite(blue, HIGH);
  }

  //128-383: fade red to green
  if ( (128 <= potValue) && (potValue < 384) ) {

    //adjust scale (-128)
    scaleValue = potValue - 128;
    //ensure blue is off
    digitalWrite(blue, HIGH);

    //red starts at 255, green starts at 0
    analogWrite(red, scaleValue);
    analogWrite(green, 255 - scaleValue);
  }

  //384-639: fade green to blue
  if ( (384 <= potValue) && (potValue < 640) ) {

    //adjust scale (-384)
    scaleValue = potValue - 384;
    //ensure red is off
    digitalWrite(red, HIGH);

    //green starts at 255, blue starts at 0
    analogWrite(green, scaleValue);
    analogWrite(blue, 255 - scaleValue);
  }

  //640-895: fade blue to red
  if ( (640 <= potValue) && (potValue < 896) ) {

    //adjust scale (-640)
    scaleValue = potValue - 640;
    //ensure green is off
    digitalWrite(green, HIGH);

    //blue starts at 255, red starts at 0
    analogWrite(blue, scaleValue);
    analogWrite(red, 255 - scaleValue);
  }

  //896-1023: all LEDs on
  if (896 <= potValue) {
    digitalWrite(red, LOW);
    digitalWrite(green, LOW);
    digitalWrite(blue, LOW);
  }
}
